--[[
***************************************
(c) msl 03/2010
Licence: GPL
***************************************
@title Tv-Mode universal
@param a Integer Start Value    [Tv]
@default a 0
@param b Keyboard Delay         [ms]
@default b 80
@param c Shooting Delay         [s]
@default c 0
@param d Limit Flash Adj. +/-   [Ev]
@default d 6
@param e Start Value Flash Adj. [Ev]
@default e 0
@param f Calculate ISO    [y=1][n=0]
@default f 1
@param g Display delay      [10th s]
@default g 15
]]

function fastshoot()
  	press("shoot_half")
  	repeat
		sleep(1)
  	until get_shooting() == true
  	press("shoot_full")
  	release("shoot_full")
  	release("shoot_half")
  	repeat
		sleep(1)
  	until get_shooting() ~= true
end

function print_tv(nn)
    tv_output = {"64","50","40","32","25","20","15","13","10","8","6","5","4",
    "3.2","2.5","2","1.6","1.3","1","0.8","0.6","0.5","0.4","0.3","1/4","1/5",
    "1/6","1/8","1/10","1/13","1/15","1/20","1/25","1/30","1/40","1/50","1/60",
    "1/80","1/100","1/125","1/160","1/200","1/250","1/320","1/400","1/500",
    "1/640","1/800","1/1000","1/1250","1/1600","1/2000","1/2500","1/3200",
    "1/4000","1/5000","1/6400","1/8000","1/10000", "1/12500","1/16000",
    "1/20000","1/25000","1/32000","1/40000","1/50000"}
return "Tv  : "..tv_output[nn +19].."s"
end 

function set_flash_mode(n)
    if get_propset() == 1 then
        set_prop(16,n)
    else
        set_prop(143,n)
    end
end

function print_flash_mode(n)
    flash_output = {"auto", "on", "off"}
return "Flash: "..flash_output[n]
end

function flash_adjust(nnn)
    if get_propset() == 1 then
        set_prop(28,nnn)
    else
        set_prop(127,nnn)
    end
end

function get_focus_status()
    if get_propset() == 1 then
        fokus_status = get_prop(11)+1
    else
        fokus_status = get_prop(6)+1
    end
return fokus_status
end

function set_focus_status(n)
    if get_propset() == 1 then
        set_prop(11,n -1)
    else
        set_prop(6,n -1)
    end
end

function print_focus_mode(n)
    mf_output = {"normal","macro","","inf."}
return "Focus: "..mf_output[n]
end

function button()
    repeat
    	key=""
    	wait_click(key_delay)
    	if     is_pressed "set"      	then key = "SET"
    	elseif is_pressed "remote"   	then key = "SET"
    	elseif is_pressed "display"  	then key = "DISP"
    	elseif is_pressed "menu"     	then key = "MENU"
    	elseif is_pressed "up"       	then key = "UP"
    	elseif is_pressed "down"     	then key = "DOWN"
    	elseif is_pressed "left"     	then key = "LEFT"
    	elseif is_pressed "right"    	then key = "RIGHT"
    --	elseif is_pressed "erase"    	then key = "ERASE"
    	elseif is_pressed "zoom_in"  	then key = "ZOOM_IN"
    	elseif is_pressed "zoom_out" 	then key = "ZOOM_OUT"
    	elseif is_pressed "shoot_half"	then key = "HALF"
        end
    until  key~=""
    if key ~= "HALF" then
        set_led (8,1)
        sleep (10)
        set_led (8,0)
    end
end

function restore()
    cls()
    set_zoom(zoom_is)
    set_flash_mode(flash_is)
    flash_adjust(0)
end

--script start

if a < -18 then a = -18 end
if a > 47  then a = 47  end
if b < 50  then b = 50  end
if c < 0   then c = 0   end
if d > 18  then d = 18  end
if e < -18 then e = -18 end
if e > 18  then e = 18  end
if f < 0 or f > 1 then f = 0 end
if g < 5   then g = 5   end

tv_input    = a
key_delay   = b
shoot_delay = c
max_zoom    = get_zoom_steps()-1
zoom_is     = get_zoom()
zoom        = zoom_is
flash_is    = get_flash_mode()
flash       = flash_is
min_fl      = d * -1
max_fl      = d
adj_fl      = e
calcSV      = f
disp_delay  = g * 100
finish      = 0

repeat
    focus_mode = get_focus_status()
    cls()
    print("[<-][->]  ",print_tv(tv_input))
    print("[UP][DOWN] Zoom:", zoom.."/".. max_zoom)
    print("[HALF]   calcISO newFocus")
    print("[SET][Remote]       Shoot")
    print("[MENU]              Setup")
    button()

    if key == "MENU" then
        repeat
        	cls()
        	if flash == 1 then
        		print("[UP]", print_flash_mode(flash+1), adj_fl.."/3 EV")
        		print("[<-][->]  Flash adjust")
        	else
            	print("[UP]     ", print_flash_mode(flash+1))
        	end
        	print("[DOWN]   ", print_focus_mode(focus_mode))
        	print("[DISP.]   Shooting")
        	print("[MENU]    Ending")
        	button()

        	if key == "DOWN" then
        		focus_mode = focus_mode + 1
        		if focus_mode == 3 then focus_mode = 4 end
        		if focus_mode == 5 then focus_mode = 1 end
        		set_focus_status(focus_mode)
            end

            if key == "UP" then
                flash = flash + 1
        	    if flash > 2 then flash = 0 end
                if flash < 0 then flash = 2 end
                set_flash_mode(flash)
            end

            if key == "RIGHT"  then adj_fl = adj_fl + 1 end
            if key == "LEFT"   then adj_fl = adj_fl - 1 end
            if adj_fl > max_fl then adj_fl = min_fl     end
            if adj_fl < min_fl then adj_fl = max_fl     end
            flash_adjust(adj_fl * 32)

            if key == "MENU" then finish = 1 end

        until key == "DISP" or key == "MENU"
        key =""
    end

    if get_focus_status() == 2 then
        set_zoom(0)
    else
        if key == "UP"  then
            zoom = zoom + 1
            if zoom > max_zoom then zoom = max_zoom end
            set_zoom(zoom)
        end
        if key == "DOWN" then
            zoom = zoom - 1
            if zoom < 0 then zoom = 0 end
            set_zoom(zoom)
        end
    end

    if key == "RIGHT"    then tv_input = tv_input + 1 end
    if key == "LEFT"     then tv_input = tv_input - 1 end
    if key == "ZOOM_IN"  then tv_input = tv_input + 5 end
    if key == "ZOOM_OUT" then tv_input = tv_input - 5 end
    if tv_input >  47 then tv_input = -18 end
    if tv_input < -18 then tv_input =  47 end

    if key == "HALF" then
        press "shoot_half"
        repeat
            until get_shooting() == true
        release "shoot_half"
        cls()
        print("Tv should be:", print_tv(get_tv96() / 32))
        print()
        print()
        sleep(disp_delay)
        if calcSV == 1 then
            Bv=get_bv96()
            Av=get_av96()
            set_sv96(tv_input * 32 + Av - Bv)
            press "shoot_half"
            repeat
                until get_shooting() == true
            release "shoot_half"
            cls()
            print("ISO market:", get_iso_market())
            print()
            print()
            sleep(disp_delay)
        end
    end

    if key == "SET" then
        if shoot_delay > 0 then
            cls()
            print("Wait "..shoot_delay.." s")
            sleep(shoot_delay * 1000)
        end
        set_tv96_direct(tv_input * 32)
        fastshoot()
    end
until finish == 1

restore()
